//
//  ViewController.m
//  Example Application
//
//  Created by Jan Christiansen on 10/1/12.
//  Copyright (c) 2012 monoid - Software Development and Consulting - Jan Christiansen.
//  All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//  * Redistributions of source code must retain the above copyright
//  notice, this list of conditions and the following disclaimer.
//
//  * Redistributions in binary form must reproduce the above
//  copyright notice, this list of conditions and the following
//  disclaimer in the documentation and/or other materials provided
//  with the distribution.
//
//  * Neither the name of Monoid - Development and Consulting -
//  Jan Christiansen nor the names of other
//  contributors may be used to endorse or promote products derived
//  from this software without specific prior written permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//

#import "ExampleViewController.h"


@interface ExampleViewController ()


@property(strong, nonatomic) MOSettingsTableViewController *settingsController;

@property(strong, nonatomic) UILabel *textLabel1;

@property(strong, nonatomic) UILabel *textLabel2;

@property(strong, nonatomic) UILabel *textLabel3;

@property(strong, nonatomic) UILabel *switchLabel;


@end



@implementation ExampleViewController


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {

    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        NSString *specificationPath = [[NSBundle mainBundle] pathForResource:@"SettingsSpecification"
                                                                      ofType:@"plist"];
        _settingsController = [[MOSettingsTableViewController alloc] initWithStyle:UITableViewStyleGrouped
                                                                 specificationFile:specificationPath];
//        _settingsController = [[MOSettingsTableViewController alloc] initWithStyle:UITableViewStylePlain
//                                                                 specificationFile:specificationPath];
    }
    return self;
}


- (void)viewDidLoad {

    [super viewDidLoad];

    self.view.backgroundColor = [UIColor whiteColor];

    CGRect captionFrame1 = CGRectMake(30, 20, 250, 20);
    UILabel *captionLabel1 = [[UILabel alloc] initWithFrame:captionFrame1];
    captionLabel1.text = @"Text Setting 1:";
    [self.view addSubview:captionLabel1];
    CGRect textLabelFrame1 = CGRectMake(30, 40, 200, 20);
    self.textLabel1 = [[UILabel alloc] initWithFrame:textLabelFrame1];
    [self.view addSubview:self.textLabel1];

    CGRect captionFrame2 = CGRectMake(30, 90, 250, 20);
    UILabel *captionLabel2 = [[UILabel alloc] initWithFrame:captionFrame2];
    captionLabel2.text = @"Switch Setting:";
    [self.view addSubview:captionLabel2];
    CGRect switchLabelFrame = CGRectMake(30, 110, 200, 20);
    self.switchLabel = [[UILabel alloc] initWithFrame:switchLabelFrame];
    [self.view addSubview:self.switchLabel];

    CGRect captionFrame3 = CGRectMake(30, 160, 250, 20);
    UILabel *captionLabel3 = [[UILabel alloc] initWithFrame:captionFrame3];
    captionLabel3.text = @"Text Setting 2:";
    [self.view addSubview:captionLabel3];
    CGRect textLabelFrame2 = CGRectMake(30, 180, 200, 20);
    self.textLabel2 = [[UILabel alloc] initWithFrame:textLabelFrame2];
    [self.view addSubview:self.textLabel2];

    CGRect captionFrame4 = CGRectMake(30, 230, 250, 20);
    UILabel *captionLabel4 = [[UILabel alloc] initWithFrame:captionFrame4];
    captionLabel4.text = @"Choice Setting:";
    [self.view addSubview:captionLabel4];
    CGRect textLabelFrame3 = CGRectMake(30, 250, 200, 20);
    self.textLabel3 = [[UILabel alloc] initWithFrame:textLabelFrame3];
    [self.view addSubview:self.textLabel3];

    UIButton *settingsButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    settingsButton.frame = CGRectMake(0, 0, 100, 50);
    settingsButton.center = CGPointMake(0.5 * self.view.bounds.size.width, 0.8 * self.view.bounds.size.height);
    [settingsButton setTitle:@"Settings" forState:UIControlStateNormal];
    [settingsButton addTarget:self
                       action:@selector(presentSettingsViewController)
             forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:settingsButton];
}

- (void)viewWillAppear:(BOOL)animated {

    [super viewWillAppear:YES];

    self.textLabel1.text = [self.settingsController settingForName:@"Text Setting 1" inGroup:0];
    if ([[self.settingsController settingForName:@"Switch Setting" inGroup:0] boolValue]) {
        self.switchLabel.text = @"ON";
    } else {
        self.switchLabel.text = @"OFF";
    }
    self.textLabel2.text = [self.settingsController settingForName:@"Text Setting 2" inGroup:1];
    NSNumber *choice = [self.settingsController settingForName:@"Choice Setting" inGroup:1];
    self.textLabel3.text = [NSString stringWithFormat:@"%d", choice.integerValue];
}

- (void)presentSettingsViewController {

    UINavigationController *navigationController = [[UINavigationController alloc]
                                                    initWithRootViewController:self.settingsController];
    [self presentViewController:navigationController animated:YES completion:nil];
}


@end
