//
//  MOChoiceController.m
//  MOSettingsTableView
//
//  Created by Jan Christiansen on 11/20/12.
//  Copyright (c) 2012 monoid - Software Development and Consulting - Jan Christiansen. All rights reserved.
//

#import "MOChoiceController.h"


@interface MOChoiceController ()


@property(strong, nonatomic) NSArray *choices;


@end


@implementation MOChoiceController


- (id)initWithChoices:(NSArray *)choices {

    self = [super initWithStyle:UITableViewStyleGrouped];
    if (self) {
        _choices = choices;
    }
    return self;
}


#pragma mark - Setting and Getting Properties

- (void)setName:(NSString *)name {

    _name = name;
    self.title = name;
}


#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {

    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView
 numberOfRowsInSection:(NSInteger)section {

    return self.choices.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView
         cellForRowAtIndexPath:(NSIndexPath *)indexPath {

    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault
                                      reuseIdentifier:CellIdentifier];
    }

    if (indexPath.row == self.choice) {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    } else {
        cell.accessoryType = UITableViewCellAccessoryNone;
    }

    cell.textLabel.text = [self.choices objectAtIndex:indexPath.row];

    return cell;
}


#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView
didSelectRowAtIndexPath:(NSIndexPath *)indexPath {

    NSIndexPath *chosenIndexPath = [NSIndexPath indexPathForRow:self.choice
                                                      inSection:0];
    UITableViewCell *chosenCell = [self.tableView cellForRowAtIndexPath:chosenIndexPath];
    chosenCell.accessoryType = UITableViewCellAccessoryNone;
    self.choice = indexPath.row;
    [self.delegate choiceController:self
                      didChoseIndex:self.choice
                       forIndexPath:self.indexPath];
    UITableViewCell *choiceCell = [self.tableView cellForRowAtIndexPath:indexPath];
    choiceCell.accessoryType = UITableViewCellAccessoryCheckmark;
    [choiceCell setSelected:NO animated:YES];
}


@end
