//
//  MOSettingsGroupSpecification.m
//  MOSettingsTableView
//
//  Created by Jan Christiansen on 10/3/12.
//  Copyright (c) 2012 monoid - Software Development and Consulting - Jan Christiansen.
//  All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//  * Redistributions of source code must retain the above copyright
//  notice, this list of conditions and the following disclaimer.
//
//  * Redistributions in binary form must reproduce the above
//  copyright notice, this list of conditions and the following
//  disclaimer in the documentation and/or other materials provided
//  with the distribution.
//
//  * Neither the name of Monoid - Development and Consulting -
//  Jan Christiansen nor the names of other
//  contributors may be used to endorse or promote products derived
//  from this software without specific prior written permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//

#import "MOSettingsGroupSpecification.h"
#import "MOSwitchSettingSpecification.h"
#import "MOTextSettingSpecification.h"
#import "MOChoiceSettingSpecification.h"

#import "NSArray+FunctionalStyle.h"


@implementation MOSettingsGroupSpecification


- (id)initWithDictionary:(NSDictionary *)dict {

    self = [super init];
    if (self) {
        _name = [dict objectForKey:@"name"];
        NSArray *tempArray = [dict objectForKey:@"settings"];
        _settings = [tempArray map:^(NSDictionary *dict) {
            NSString *style = [dict objectForKey:@"style"];
            MOSettingSpecification *specification;
            if ([style isEqualToString:@"switch"]) {
                specification = [[MOSwitchSettingSpecification alloc] initWithDictionary:dict];
            } else if ([style isEqualToString:@"text"]) {
                specification = [[MOTextSettingSpecification alloc] initWithDictionary:dict];
            } else if ([style isEqualToString:@"choice"]) {
                specification = [[MOChoiceSettingSpecification alloc] initWithDictionary:dict];
            }
            return specification;
        }];
    }
    return self;
}


@end
